#include <metal_stdlib>
using namespace metal;

fragment float4 fs_solid() {
	// Solid red!
	return float4(1, 0, 0, 1);
}

kernel void test(device atomic_uint& out [[buffer(0)]], texture2d<float> color [[texture(0)]], depth2d<float> depth [[texture(1)]], ushort2 pos [[thread_position_in_grid]]) {
	bool color_wrote = color.read(pos).r != 0;
	bool depth_wrote = depth.read(pos) != 0;
	if (color_wrote != depth_wrote) {
		atomic_fetch_add_explicit(&out, 1, memory_order_relaxed);
	}
}
